//
// BugEffect.fx
// Pass
//		0	:	Normal Effect


/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;								// [hs
float4x4	mView;								// r[s
float4x4	mProj;								// es
float4		Color = 1.0f;						// {F

float		Alpha;								// At@l
float		MinAlpha = 0.4f;					// ŒAt@l
float		Offset;								// ItZbg

/*****  eNX`  *****/
// C
texture Tex;
sampler TexSmp = sampler_state {
	Texture = <Tex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};


/*****  \  *****/
// _VF[_sNZVF[_ɓn\

// ʏ
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float3 WorldPos	: TEXCOORD1;	// 3DW
	float2 TexUV	: TEXCOORD0;	// eNX`UV
	float2 EfTexUV	: TEXCOORD3;	// GtFNgeNX`UV
	float4 Col		: COLOR0;		// _J[
	float3 Normal	: TEXCOORD2;	// @
};


/*****  _VF[_  *****/

// o[g
VS_OUT VSBasic(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,				// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);
	Out.EfTexUV = Out.Pos.xy;

	Out.TexUV = texUV;

	//float3 L = -LightDir.xyz;

	Out.Normal = normal.xyz;
	//Out.Normal = normalize(EyePos.xyz - Out.WorldPos);

	//Out.Col = Diffuse * max(Ambient, dot(Out.Normal, L));

	return Out;
}


/*****  sNZVF[_  *****/

// ʏ
float4 PSBasic(VS_OUT In) : COLOR0
{
	float4 retCol = Color;
	float4 texCol = tex2D(TexSmp, In.TexUV);
	retCol.a = texCol.r;
	retCol.a = max(MinAlpha, retCol.a * Alpha);
	return retCol;
}

float4 PSOffset(VS_OUT In) : COLOR0
{
	float4 retCol = Color;
	float2 texUV = In.TexUV;
	texUV.y += Offset;
	float4 texCol = tex2D(TexSmp, texUV.y);
	retCol.a = texCol.r;
	retCol.a = max(0.2f, retCol.a * Alpha);
	return retCol;
}

/*****  eNjbN  *****/
technique Tech {

	// Normal
	pass Normal
	{
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSBasic();
	}

	pass Offset
	{
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSOffset();
	}
}