//
// BugEffect.fx
// Pass
//		0	:	Normal Effect


/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;								// [hs
float4x4	mView;								// r[s
float4x4	mProj;								// es
float4		LightDir;							// Cg
float4		EyePos;								// _ʒu
float4		Diffuse = 1.0f;						// {F
float		Ambient = 0.0f;						// F
float4		Specular = 1.0f;					// ːF
float		Power = 1.0f;						// ˂̗

float4		Color;								// F
float		Alpha = 1.0f;						// At@l	
float		Offset = 0;							// ItZbg
float		AlphaOffset = 0;					// At@}bv ItZbg
float		InnerAlpha = 0;


/*****  eNX`  *****/
// C
texture Tex;
sampler TexSmp = sampler_state {
	Texture = <Tex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

// GtFNgeNX`
texture EfTex;
sampler EfTexSmp = sampler_state {
	Texture = <EfTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

// At@}bv
texture AlphaMap;
sampler AlphaMapSmp = sampler_state {
	Texture = <AlphaMap>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

/*****  \  *****/
// _VF[_sNZVF[_ɓn\

// ʏ
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float3 WorldPos	: TEXCOORD1;	// 3DW
	float2 TexUV	: TEXCOORD0;	// eNX`UV
	float2 EfTexUV	: TEXCOORD3;	// GtFNgeNX`UV
	float4 Col		: COLOR0;		// _J[
	float3 Normal	: TEXCOORD2;	// @
	float4 Pos2d	: TEXCOORD4;
};


/*****  _VF[_  *****/

VS_OUT VSWire(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,				// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);
	Out.EfTexUV = Out.Pos.xy;
	Out.Pos2d = Out.Pos;

	Out.TexUV = texUV;

	//float3 L = -LightDir.xyz;

	//Out.Normal = normal.xyz;
	Out.Normal = normalize(EyePos.xyz - Out.WorldPos);

	//Out.Col = Diffuse * max(Ambient, dot(Out.Normal, L));

	return Out;
}

VS_OUT VSAppear(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,				// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);
	Out.EfTexUV = Out.Pos.xy;

	Out.TexUV = texUV;

	//float3 L = -LightDir.xyz;

	Out.Normal = normal.xyz;

	//Out.Col = Diffuse * max(Ambient, dot(Out.Normal, L));

	return Out;
}

/*****  sNZVF[_  *****/

float4 PSWire(VS_OUT In) : COLOR0
{
	float4 retCol = Color;
	
	float2 efTexPos = (float2)0;
	efTexPos.x = (In.EfTexUV.x / 64.0f);
	efTexPos.y = -1 * (In.EfTexUV.y / 48.0f);
	efTexPos += Offset;
	float4 efTexColor = tex2D(EfTexSmp, efTexPos);
	
	retCol += efTexColor;

	retCol.a *= Alpha;

	return retCol;
}

float4 PSAppear(VS_OUT In) : COLOR0
{
	float3 w_normal = normalize(In.Normal);

	float LPow = max(0, dot(-LightDir.xyz, w_normal));

	float3 vCam = normalize(EyePos.xyz - In.WorldPos);
	float3 vRef = LightDir.xyz + 2.0f * dot(w_normal, -LightDir.xyz) * w_normal;
	float SpePow = pow(max(0,dot(vCam,vRef)), Power);
	float4 Spe = Specular * SpePow;

	float4 Col = Diffuse * tex2D(TexSmp, In.TexUV);
	Col.rgb *= min(1, LPow + Ambient);

	float2 efTexPos = (float2)0;
	efTexPos.x = (In.EfTexUV.x / 64.0f);
	efTexPos.y = -1 * (In.EfTexUV.y / 48.0f);
	efTexPos += Offset;
	float4 efTexColor = tex2D(EfTexSmp, efTexPos);
	efTexColor *= Color;
	efTexColor.rgb *= 0.1f;

	float4 retCol = Col + Spe + efTexColor;
	retCol.a = Col.a;
	retCol.a *= Alpha;
	clip(retCol.a - 0.01f);
	return retCol;
	//return efTexColor;
}

float4 PSWireInner(VS_OUT In) : COLOR0
{
	float4 apColor = PSAppear(In);
	apColor.a *= InnerAlpha;

	//float3 pos2d = In.Pos2d.xyz / In.Pos2d.w;
	//float2 uv = pos2d.xy * 0.5 + 0.5;
	//uv.x += AlphaOffset * 0.015625;	// 1/64

	//float4 alpha = tex2D(AlphaMapSmp, uv);
	//apColor.a = alpha.r;

	return apColor;
}

/*****  eNjbN  *****/
technique Wire {
	pass P01
	{
		VertexShader = compile vs_3_0 VSWire();
		PixelShader = compile ps_3_0 PSWire();
	}

	pass P02
	{
		VertexShader = compile vs_3_0 VSWire();
		PixelShader = compile ps_3_0 PSWireInner();
	}
}

technique Appear {
	pass P01
	{
		VertexShader = compile vs_3_0 VSAppear();
		PixelShader = compile ps_3_0 PSAppear();
	}
}