//
// BugEffect.fx
// Pass
//		0	:	Normal Effect


/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;								// [hs
float4x4	mView;								// r[s
float4x4	mProj;								// es
float4		LightDir;							// Cg
float4		EyePos;								// _ʒu
float4		Diffuse = 1.0f;						// {F
float		Ambient = 0.0f;						// F
float4		Specular = 1.0f;					// ːF
float		Power = 1.0f;						// ˂̗

float2		EfTexel;							// eNZTCY
int			GradRange = 5;						// ڂ
float4		ColorRatio;							// F䗦
float		Alpha = 1.0f;						// At@l	
float		Offset = 0;							// ItZbg


/*****  eNX`  *****/
// C
texture Tex;
sampler TexSmp = sampler_state {
	Texture = <Tex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

// GtFNgeNX`
texture EfTex;
sampler EfTexSmp = sampler_state {
	Texture = <EfTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};


/*****  \  *****/
// _VF[_sNZVF[_ɓn\

// ʏ
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float3 WorldPos	: TEXCOORD1;	// 3DW
	float2 TexUV	: TEXCOORD0;	// eNX`UV
	float2 EfTexUV	: TEXCOORD3;	// GtFNgeNX`UV
	float4 Col		: COLOR0;		// _J[
	float3 Normal	: TEXCOORD2;	// @
};


/*****  _VF[_  *****/

// o[g
VS_OUT VSBasic(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,				// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);
	Out.EfTexUV = Out.Pos.xy;

	Out.TexUV = texUV;

	//float3 L = -LightDir.xyz;

	//Out.Normal = normal.xyz;
	Out.Normal = normalize(EyePos.xyz - Out.WorldPos);

	//Out.Col = Diffuse * max(Ambient, dot(Out.Normal, L));

	return Out;
}


/*****  sNZVF[_  *****/

// o[g
float4 PSBasic(VS_OUT In) : COLOR0
{
	float3 L = -LightDir.xyz;
	float LPow = max(0, dot(L, In.Normal));

	float3 vCam = normalize(EyePos.xyz - In.WorldPos);		// (J)ւ̕
	float3 vRef = LightDir.xyz + 2.0f * dot(In.Normal, L) * In.Normal;
	float SpePow = pow(max(0, dot(vCam, vRef)), 2.0f);
	float4 Spe = Specular * SpePow;

	float4 Col = (float4)0;
	Col = Diffuse * tex2D(TexSmp, In.TexUV);
	Col.rgb *= min(1, LPow + Ambient);

	float2 efTexPos = (float2)0;
	efTexPos.x = (In.EfTexUV.x * 0.015625f);			// 0.015625f == 1 / 64.0f
	efTexPos.y = -1 * (In.EfTexUV.y * 0.020833f);		// 0.020833f == 1 / 48.0f 
	efTexPos += Offset;
	float4 efColor = (float4)0;
	efColor = tex2D(EfTexSmp, efTexPos);
	//efColor.rgb *= ColorRatio.rgb;
	efColor.rgb = max(efColor.rgb, ColorRatio.rgb);

	Col.rgb = Col.rgb * 0.1f + efColor.rgb * 0.9f;

	/*** add ***/
	Col.a = 0.5f;
	Col.rgb *= 0.7f;
	/***********/

	float4 retCol = Col + Spe;
	retCol.a *= Alpha;
	return retCol;
}


float4 PSVisibleOff(VS_OUT In) : COLOR0
{
	float3 L = -LightDir.xyz;
	float LPow = max(0, dot(L, In.Normal));

	float3 vCam = normalize(EyePos.xyz - In.WorldPos);		// (J)ւ̕
	float3 vRef = LightDir.xyz + 2.0f * dot(In.Normal, L) * In.Normal;
	float SpePow = pow(max(0, dot(vCam, vRef)), 2.0f);
	float4 Spe = Specular * SpePow;

	float4 Col = (float4)0;
	Col = Diffuse * tex2D(TexSmp, In.TexUV);
	Col.rgb *= min(1, LPow + Ambient);

	float2 efTexPos = (float2)0;
	efTexPos.x = (In.EfTexUV.x * 0.015625f);			// 0.015625f == 1 / 64.0f
	efTexPos.y = -1 * (In.EfTexUV.y * 0.020833f);		// 0.020833f == 1 / 48.0f 
	efTexPos += Offset;
	float4 efColor = (float4)0;
	efColor = tex2D(EfTexSmp, efTexPos);
	efColor.rgb *= ColorRatio.rgb;
	efColor.rgb = max(efColor.rgb, 0.5f);
	efColor.a = 0.5f;
	return efColor;

	/*Col.rgb = Col.rgb * 0.1f + efColor.rgb * 0.9f;
	float4 retCol = Col + Spe;
	retCol.a *= Alpha;*/
	//return retCol;
}


/*****  eNjbN  *****/
technique Normal {

	// Normal
	pass P01
	{
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSBasic();
	}
}

technique VisibleOff {
	pass P01
	{
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSVisibleOff();
	}
}