//
// BugEffect.fx
// Pass
//		0	:	Normal Effect


/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;			// [hs
float4x4	mView;			// r[s
float4x4	mProj;			// ˉes
float3		Eye;			// _ʒu
float		TexOffset;		// ItZbg
float2		NoiseTexel;		// io[eNX` eNZTCY
float		ratio = 0.8;	// (C:io[ = ratio:1-ratio)
float		Alpha = 1.0f;	// At@
float4		Color = float4(1, 1, 1, 1);	// J[
float2		RTTexel;		// 

// 0.015625f = 1 / 64.0f
// 0.020833f = 1 / 48.0f
float2		Division = float2(0.015625f, 0.020833f);		// Zn(1/Z)

/*****  eNX`  *****/

// mCYeNX`
texture NoiseTex;
sampler NoiseTexSmp = sampler_state {
	Texture = <NoiseTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

texture RTTex;
sampler RTTexSmp = sampler_state {
	Texture = <RTTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};


/*****  \  *****/
// _VF[_sNZVF[_ɓn\

// ʏ
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float3 WorldPos	: TEXCOORD0;	// 3DW
	float4 ScPos	: TEXCOORD1;	// Wϊς2DW(PosƓl)
	float2 TexUV	: TEXCOORD2;	// eNX`UV
	float3 Normal	: TEXCOORD3;	// @
	float3 Eye		: TEXCOORD4;	// _ - _ւ̃xNg
};


/*****  _VF[_  *****/
VS_OUT VS(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,				// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);
	Out.ScPos = Out.Pos;

	Out.TexUV = texUV;
	Out.Normal = normalize(normal);

	Out.Eye = normalize(pos.xyz - Eye);

	return Out;
}

/*****  sNZVF[_  *****/

float4 PS(VS_OUT In) : COLOR0
{
	
	// @xNgƎ_xNg̍
	float2 Offset = In.Eye.xy - In.Normal.xy;

	// XN[Wɕϊ
	float2 pos2d;
	pos2d = In.ScPos.xy / In.ScPos.w;
	pos2d = pos2d * 0.5 + 0.5f;
	pos2d.y = 1 - pos2d.y;

	//	ʊÕsNZj
	clip(pos2d + 0.01f);
	clip((1 - pos2d) + 0.01f);

	// ItZbglZ
	float p = dot(In.Normal, In.Eye);	// ␳l
	pos2d += Offset * p;

	// W
	pos2d += RTTexel * 0.5f;
	// l͈͓ɃNv
	pos2d = clamp(pos2d, RTTexel, 1.0f - RTTexel);

	// _[^[Qbg̃eNX`TCY1024*512̂
	// EChETCY(640*480)̍Wɕϊ
	pos2d.x *= 0.625f;			// 0.625f == 640.0f / 1024.0f
	pos2d.y *= 0.9375f;			// 0.9375f == 480.0f / 512.0f
	
	// _[^[QbgF擾
	float4 texColor = tex2D(RTTexSmp, pos2d);

	// mCYeNX`F擾
	float2 noiseTexUV = (float2)0;
	noiseTexUV = In.ScPos.xy;
	noiseTexUV.x *= Division.x;
	noiseTexUV.y *= Division.y;
	noiseTexUV.y *= -1;
	noiseTexUV += NoiseTexel * 0.5;
	float4 noiseColor = tex2D(NoiseTexSmp, noiseTexUV + TexOffset);

	// mCY̐FZ
	float4 retCol = (((texColor) * Color) * noiseColor) + Color * 0.25f;

	// At@Z
	retCol.a *= Alpha;

	return retCol;
}



/*****  eNjbN  *****/
technique Normal {

	// Normal
	pass P01
	{
		VertexShader = compile vs_3_0 VS();
		PixelShader = compile ps_3_0 PS();
	}
}