//
// CommunicateEffect.fx
// 
//		


/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;								// [hs
float4x4	mView;								// r[s
float4x4	mProj;								// es
float4		Color;								// J[

float		Power;								// SinW̑傫
float		Alpha;								// At@l

/*****  eNX`  *****/
// C
texture Tex;
sampler TexSmp = sampler_state {
	Texture = <Tex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = GAUSSIANQUAD;
	AddressU = Wrap;
	AddressV = Clamp;
};



/*****  \  *****/
// _VF[_sNZVF[_ɓn\

// ʏ
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float3 WorldPos	: TEXCOORD1;	// 3DW
	float2 TexUV	: TEXCOORD0;	// eNX`UV
	float4 Col		: COLOR0;		// _J[
	float3 Normal	: TEXCOORD2;	// @
};

/*****  _VF[_  *****/
VS_OUT VSBasic(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,					// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);

	Out.TexUV = texUV;

	Out.Normal = normal.xyz;

	return Out;
}

/*

*/

/*****  sNZVF[_  *****/
float4 PSBottom(VS_OUT In) : COLOR0
{
	float4 retCol = Color;
	float4 texCol = tex2D(TexSmp, In.TexUV);
	retCol.a = texCol.r;
	return retCol;
}

float4 PSSide(VS_OUT In) : COLOR0
{
	float4 retCol = Color;
	float offset = In.TexUV.x * (3.14159265f * 4.0f);
	float addv = abs(sin(offset)) * Power;
	float2 texUV = In.TexUV;
	texUV.y -= 0.5f;
	texUV.y -= addv;
	texUV.y += 0.5f;
	float4 texCol = tex2D(TexSmp, texUV);

	retCol.a = texCol.r;
	retCol.a *= Alpha;
	return retCol;
}

/*****  eNjbN  *****/
technique Tech {
	pass Bottom
	{
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSBottom();
	}

	pass Side {
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSSide();
	}
}
