//
// CommunicateEffect.fx
// 
//		


/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;								// [hs
float4x4	mView;								// r[s
float4x4	mProj;								// es
float4		Color;								// J[

// CommunicateSphere(com)
float		comOffset;

// Packet (pck)
float4		pckCenter;
float		pckRdius;
float		pckAlpha;
float		pckGAlpha;

/*****  eNX`  *****/
// C
texture Tex;
sampler TexSmp = sampler_state {
	Texture = <Tex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

texture comAlphaMap;
sampler ComAlphaMapSmp = sampler_state {
	Texture = <comAlphaMap>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};



/*****  \  *****/
// _VF[_sNZVF[_ɓn\

// ʏ
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float3 WorldPos	: TEXCOORD1;	// 3DW
	float2 TexUV	: TEXCOORD0;	// eNX`UV
	float4 Col		: COLOR0;		// _J[
	float3 Normal	: TEXCOORD2;	// @
};

/*****  ėp֐  *****/
float2 CalcScreenPos(float4 _pos)
{
	float2 Out = _pos.xy / _pos.w;
	Out = Out * 0.5f + 0.5f;
	Out.y = 1 - Out.y;
	Out.x *= 640;
	Out.y *= 480;
	return Out;
}

/*****  _VF[_  *****/
VS_OUT VSBasic(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,					// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);

	Out.TexUV = texUV;

	Out.Normal = normal.xyz;

	return Out;
}

/*

*/

/*****  sNZVF[_  *****/
float4 PSComSphere(VS_OUT In) : COLOR0
{
	float4 retCol = Color;
	float2 texUV = In.TexUV;
	texUV.y = texUV.y * 0.5f + 0.5f - (comOffset * 0.5f);
	float4 texCol = tex2D(TexSmp, texUV);
	retCol.a *= texCol.r;
	float alpha = tex2D(ComAlphaMapSmp, float2(comOffset, 0.5f));
	retCol.a *= alpha;
	return retCol;
}

float4 PSPacket(
	VS_OUT In,
	float2 pos	: VPOS
	) : COLOR0
{
	float4 cpos;
	cpos = mul(pckCenter, mWorld);
	float3 cwpos;
	cwpos = cpos.xyz;

	//cpos = mul(cpos, mView);
	//cpos = mul(cpos, mProj);

	/*float2 c2Dpos;
	c2Dpos = CalcScreenPos(cpos);*/
	/*c2Dpos = cpos.xy / cpos.w;
	c2Dpos = c2Dpos * 0.5f + 0.5f;*/

	float3 dif = cwpos - In.WorldPos;
	float len = length(dif);
	//float4 retCol = {1,1,0,1};
	//retCol.a = saturate(len / 10.0f);

	float4 retCol = Color;
	retCol.a = pckAlpha;
	retCol.a *= pckGAlpha;

	return retCol;
}

/*****  eNjbN  *****/
technique CommunicateSphere {
	pass CommunicateSphere
	{
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSComSphere();
		FillMode = WIREFRAME;
	}
}

technique Packet {
	pass Packet
	{
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSPacket();
	}
}