//
// BugEffect.fx
// Pass
//		0	:	Normal Effect


/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;			// [hs
float4x4	mView;			// r[s
float4x4	mProj;			// ˉes
float2		NoiseTexel;		// mCYeNX` eNZTCY
float2		RTTexel;		// _[^[Qbg eNZTCY
float		Alpha = 1.0f;	// At@
float2		NoiseOffset = float2(0, 0);	// mCYeNX`̎QUVW̃ItZbgl
float		Power = 0.05f;			// c݂̑傫

/*****  eNX`  *****/

// mCYeNX`
texture NoiseTex;
sampler NoiseTexSmp = sampler_state {
	Texture = <NoiseTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

texture RTTex;
sampler RTTexSmp = sampler_state {
	Texture = <RTTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};


/*****  \  *****/
// _VF[_sNZVF[_ɓn\

// ʏ
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float3 WorldPos	: TEXCOORD0;	// 3DW
	float4 ScPos	: TEXCOORD1;	// Wϊς2DW(PosƓl)
	float2 TexUV	: TEXCOORD2;	// eNX`UV
};


/*****  _VF[_  *****/
VS_OUT VS(
	float4 pos		: POSITION,				// W
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);
	Out.ScPos = Out.Pos;

	Out.TexUV = texUV;

	return Out;
}

/*****  sNZVF[_  *****/

float4 PS(VS_OUT In) : COLOR0
{
	// XN[Wɕϊ
	float2 pos2d;
	pos2d = In.ScPos.xy / In.ScPos.w;
	pos2d = pos2d * 0.5 + 0.5f;
	pos2d.y = 1 - pos2d.y;
	//pos2d += RTTexel * 0.5f;

	// mCYeNX`F擾
	float2 noiseTexUV = pos2d;
	float4 noiseColor = tex2D(NoiseTexSmp, noiseTexUV + NoiseOffset);

	// mCYJ[̒lItZbglƂĈړ
	float2 offset;
	offset.x = distance(noiseColor.x, noiseColor.y);
	offset.y = distance(noiseColor.w, noiseColor.z);
	pos2d += normalize(offset) * Power;

	// 0y1ȏ̒l␳
	pos2d = clamp(pos2d, RTTexel, 1 - RTTexel);

	// _[^[Qbg̃eNX`TCY1024*512̂
	// EChETCY(640*480)̍Wɕϊ
	// 0.625f = 640.0f / 1024.0f
	pos2d.x *= 0.625f;
	// 0.9375f = 480.0f / 512.0f
	pos2d.y *= 0.9375f;
	
	// _[^[QbgF擾
	float4 texColor = tex2D(RTTexSmp, pos2d);

	// mCY̐FZ
	float4 retCol = texColor * max(0.5, noiseColor);

	retCol.a = Alpha;

	return retCol;
}



/*****  eNjbN  *****/
technique Normal {

	// Normal
	pass P01
	{
		VertexShader = compile vs_3_0 VS();
		PixelShader = compile ps_3_0 PS();
	}
}