//
// RadioWaveEffect.fx
// Pass
//		0	:	Normal Effect


/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;								// [hs
float4x4	mView;								// r[s
float4x4	mProj;								// es
float4		LightDir;							// Cg
float4		EyePos;								// _ʒu
float4		Diffuse;							// fBt[Y
float4		ColorRatio;							// F䗦
float4		Center;								// SW
float		Radius;								// a

/*****  eNX`  *****/
// C
texture Tex;
sampler TexSmp = sampler_state {
	Texture = <Tex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};



/*****  \  *****/
// _VF[_sNZVF[_ɓn\

// ʏ
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float3 WorldPos	: TEXCOORD1;	// 3DW
	float2 TexUV	: TEXCOORD0;	// eNX`UV
	float4 Col		: COLOR0;		// _J[
	float3 Normal	: TEXCOORD2;	// @
	float4 EfPos	: TEXCOORD3;	// PSp2DW
};

/*****  ėp֐  *****/
float2 CalcScreenPos(float4 _pos)
{
	float2 Out = _pos.xy / _pos.w;
	Out = Out * 0.5f + 0.5f;
	Out.y = 1 - Out.y;
	Out.x *= 640;
	Out.y *= 480;
	return Out;
}

/*****  _VF[_  *****/
VS_OUT VSBasic(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,					// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);
	Out.EfPos = Out.Pos;

	Out.TexUV = texUV;

	Out.Normal = normal.xyz;

	return Out;
}

/*

*/

/*****  sNZVF[_  *****/
float4 PSBasic(VS_OUT In) : COLOR0
{
	float4 retCol = Diffuse;
	float4 texCol = tex2D(TexSmp, In.TexUV);
	retCol.a *= texCol.r;

	return retCol;
	//return Diffuse;
}


/*****  eNjbN  *****/
technique Normal {

	// Normal
	pass P01
	{
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSBasic();
		CullMode = CCW;
		ZEnable = false;
		ZWriteEnable = false;
	}
}