//
// BugEffect.fx
// Pass
//		0	:	Normal Effect


/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;			// [hs
float4x4	mView;			// r[s
float4x4	mProj;			// ˉes

float2		InputTexel;

/*****  eNX`  *****/

texture InputTex;
sampler InputTexSmp = sampler_state {
	Texture = <InputTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

/*****  \  *****/
// None

/*****  sNZVF[_  *****/
float4 PSBlurX(float2 texUV : TEXCOORD0) : COLOR0
{
	float4 color = (float4)0;

	for (int i = 0; i < 5; i++) {
		color += tex2D(InputTexSmp, texUV + float2(InputTexel.x * i, 0));
		color += tex2D(InputTexSmp, texUV + float2(-InputTexel.x * i, 0));
	}

	color *= 0.1;
	return color;
}

float4 PSBlurY(float2 texUV : TEXCOORD0) : COLOR0
{
	float4 color = (float4)0;

	for (int i = 0; i < 5; i++) {
		color += tex2D(InputTexSmp, texUV + float2(0, InputTexel.x * i));
		color += tex2D(InputTexSmp, texUV + float2(0, -InputTexel.x * i));
	}

	color *= 0.1;
	return color;
}

float4 PSNormal(float2 texUV : TEXCOORD0) : COLOR0
{
	texUV += InputTexel * 0.5;
	float4 color = tex2D(InputTexSmp, texUV);
	return color;
}

/*****  eNjbN  *****/
technique Tech {

	// Normal
	pass BlurX
	{
		PixelShader = compile ps_3_0 PSBlurX();
		ZEnable = false;
		ZWriteEnable = false;
	}

	pass BlurY
	{
		PixelShader = compile ps_3_0 PSBlurY();
		ZEnable = false;
		ZWriteEnable = false;
	}

	pass Normal
	{
		PixelShader = compile ps_3_0 PSNormal();
		ZEnable = false;
		ZWriteEnable = false;
	}
}