/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;								// [hs
float4x4	mView;								// r[s
float4x4	mProj;								// es
float4		LightDir;							// Cg
float4		EyePos;								// _ʒu
float4		Diffuse = 1.0f;						// {F
float		Ambient = 0.0f;						// F
float4		Specular = 1.0f;					// ːF


float2		OverTexel;							// eNZ

float		OffsetV;							// VItZbg
float		Range;								// ͈
float		LowerAlpha = 0.4f;					// At@l
float		UpperAlpha = 0.5f;					// At@l


/*****  eNX` Tv  *****/

// C
texture MainTex;
sampler MainSmp = sampler_state {
	Texture = <MainTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

// H
texture OverTex;
sampler OverSmp = sampler_state {
	Texture = <OverTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};


/*****  \  *****/
// _VF[_sNZVF[_ɓn\

// ʏ
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float3 WorldPos	: TEXCOORD1;	// 3DW
	float2 TexUV	: TEXCOORD0;	// eNX`UV
	float4 Col		: COLOR0;		// _J[
	float3 Normal	: TEXCOORD2;	// @
	float4 ProjPos	: TEXCOORD3;
};



/*****  _VF[_  *****/

VS_OUT VS(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,				// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;



	Out.Pos = mul(pos, mWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);
	Out.ProjPos = Out.Pos;

	Out.TexUV = texUV;

	//float3 L = -LightDir.xyz;

	Out.Normal = normal.xyz;

	//Out.Col = Diffuse * max(Ambient, dot(Out.Normal, L));

	return Out;
}



/*****  sNZVF[_  *****/

// 
float4 PSSide(VS_OUT In) : COLOR0
{
	// ʊÕsNZj
	float2 pos2d;
	pos2d = In.ProjPos.xy / In.ProjPos.w;
	pos2d = pos2d * 0.5 + 0.5f;
	pos2d.y = 1 - pos2d.y;
	clip(pos2d + 0.01f);
	clip((1 - pos2d) + 0.01f);


	float4 Col = (float4)0;
	Col = Diffuse * tex2D(MainSmp, In.TexUV);

	// Add
	float dif = min(Range, abs(OffsetV - In.TexUV.y));
	float alpha = 1 - (dif / Range);
	float4 Over = (float4)0;
	In.TexUV += OverTexel;
	Over = tex2D(OverSmp, In.TexUV);
	
	//float OverValue = max(alpha * 0.5f, Over.r) * min(max(alpha, LowerAlpha), UpperAlpha);
	float OverValue = (Over.r * LowerAlpha) + (alpha * (UpperAlpha - LowerAlpha)) * Over.r;

	int4 ColOffset = (int4)0;
	int4 ColOffsetDia = (int4)0;
	float4 tmpCol = (float4)0;
	[unroll(5)] for (int i = 0; i < 3; i += 1) {
		tmpCol = tex2D(OverSmp, In.TexUV + float2(-(OverTexel.x * i), 0));
		ColOffset.x = max(ColOffset.x, (int)round(tmpCol.r * i));
		tmpCol = tex2D(OverSmp, In.TexUV + float2(0, -(OverTexel.y * i)));
		ColOffset.y = max(ColOffset.y, (int)round(tmpCol.r * i));
		tmpCol = tex2D(OverSmp, In.TexUV + float2(OverTexel.x * i, 0));
		ColOffset.z = max(ColOffset.z, (int)round(tmpCol.r * i));
		tmpCol = tex2D(OverSmp, In.TexUV + float2(0, OverTexel.y * i));
		ColOffset.w = max(ColOffset.w, (int)round(tmpCol.r * i));

		tmpCol = tex2D(OverSmp, In.TexUV + float2(-(OverTexel.x * i), -(OverTexel.y * i)));
		ColOffsetDia.x = max(ColOffsetDia.x, (int)round(tmpCol.r * i));
		tmpCol = tex2D(OverSmp, In.TexUV + float2(OverTexel.x * i, -(OverTexel.y * i)));
		ColOffsetDia.y = max(ColOffsetDia.y, (int)round(tmpCol.r * i));
		tmpCol = tex2D(OverSmp, In.TexUV + float2(OverTexel.x * i, OverTexel.y * i));
		ColOffsetDia.z = max(ColOffsetDia.z, (int)round(tmpCol.r * i));
		tmpCol = tex2D(OverSmp, In.TexUV + float2(-(OverTexel.x * i), OverTexel.y * i));
		ColOffsetDia.w = max(ColOffsetDia.w, (int)round(tmpCol.r * i));
	}

	float cor = (ColOffset.x + ColOffset.y + ColOffset.z + ColOffset.w) + (ColOffsetDia.x + ColOffsetDia.y + ColOffsetDia.z + ColOffsetDia.w);
	cor = (cor * 0.0416666f);

	Col.rgb += OverValue + (cor * alpha);

	return Col;
}


float4 PSUD(VS_OUT In) : COLOR0
{
	// ʊÕsNZj
	float2 pos2d;
	pos2d = In.ProjPos.xy / In.ProjPos.w;
	pos2d = pos2d * 0.5 + 0.5f;
	pos2d.y = 1 - pos2d.y;
	clip(pos2d + 0.01f);
	clip((1 - pos2d) + 0.01f);

	float4 Col = (float4)0;
	Col = Diffuse * tex2D(MainSmp, In.TexUV);

	// Add
	float2 difuv;
	difuv.x = abs(OffsetV - abs(In.TexUV.x - 0.5f));
	difuv.y = abs(OffsetV - abs(In.TexUV.y - 0.5f));

	float dif = min(Range, (difuv.x + difuv.y) * 0.5f);
	float alpha = 1 - (dif / Range);
	float4 Over = (float4)0;
	In.TexUV += OverTexel;
	Over = tex2D(OverSmp, In.TexUV);

	//float OverValue = max(alpha * 0.5f, Over.r) * min(max(alpha, LowerAlpha), UpperAlpha);
	float OverValue = (Over.r * LowerAlpha) + (alpha * (UpperAlpha - LowerAlpha)) * Over.r;

	int4 ColOffset = (int4)0;
	int4 ColOffsetDia = (int4)0;
	float4 tmpCol = (float4)0;
	[unroll(5)] for (int i = 0; i < 3; i += 1) {
		tmpCol = tex2D(OverSmp, In.TexUV + float2(-(OverTexel.x * i), 0));
		ColOffset.x = max(ColOffset.x, (int)round(tmpCol.r * i));
		tmpCol = tex2D(OverSmp, In.TexUV + float2(0, -(OverTexel.y * i)));
		ColOffset.y = max(ColOffset.y, (int)round(tmpCol.r * i));
		tmpCol = tex2D(OverSmp, In.TexUV + float2(OverTexel.x * i, 0));
		ColOffset.z = max(ColOffset.z, (int)round(tmpCol.r * i));
		tmpCol = tex2D(OverSmp, In.TexUV + float2(0, OverTexel.y * i));
		ColOffset.w = max(ColOffset.w, (int)round(tmpCol.r * i));

		tmpCol = tex2D(OverSmp, In.TexUV + float2(-(OverTexel.x * i), -(OverTexel.y * i)));
		ColOffsetDia.x = max(ColOffsetDia.x, (int)round(tmpCol.r * i));
		tmpCol = tex2D(OverSmp, In.TexUV + float2(OverTexel.x * i, -(OverTexel.y * i)));
		ColOffsetDia.y = max(ColOffsetDia.y, (int)round(tmpCol.r * i));
		tmpCol = tex2D(OverSmp, In.TexUV + float2(OverTexel.x * i, OverTexel.y * i));
		ColOffsetDia.z = max(ColOffsetDia.z, (int)round(tmpCol.r * i));
		tmpCol = tex2D(OverSmp, In.TexUV + float2(-(OverTexel.x * i), OverTexel.y * i));
		ColOffsetDia.w = max(ColOffsetDia.w, (int)round(tmpCol.r * i));
	}

	float cor = (ColOffset.x + ColOffset.y + ColOffset.z + ColOffset.w) + (ColOffsetDia.x + ColOffsetDia.y + ColOffsetDia.z + ColOffsetDia.w);
	cor = (cor * 0.0416666f);

	Col.rgb += OverValue + (cor * alpha);

	return Col;
}



/*****  eNjbN  *****/
technique tech {

	// Head
	pass Side
	{
		VertexShader = compile vs_3_0 VS();
		PixelShader = compile ps_3_0 PSSide();
		CullMode = CCW;
	}

	pass YFace
	{
		VertexShader = compile vs_3_0 VS();
		PixelShader = compile ps_3_0 PSUD();
		CullMode = CCW;
	}
}