//
// SpPatch Effect
// Pass
//		0	:	Normal Effect


/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;								// [hs
float4x4	mView;								// r[s
float4x4	mProj;								// es

float2		RTTexel;							// _[^[Qbg eNZTCY
float2		Texel;								// eNZTCY
float		Alpha = 1.0f;						// At@l	
float2		Offset;								// ItZbg

// _[^[Qbg
texture RTTex;
sampler RTTexSmp = sampler_state {
	Texture = <RTTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Clamp;
	AddressV = Clamp;
};

// GtFNgeNX`
texture EfTex;
sampler EfTexSmp = sampler_state {
	Texture = <EfTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};


/*****  \  *****/
// _VF[_sNZVF[_ɓn\

// ʏ
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float4 ProjPos	: TEXCOORD0;	// 3DW
	float2 EfTexUV	: TEXCOORD1;	// GtFNgeNX`UV
};


/*****  _VF[_  *****/

// o[g
VS_OUT VSBasic(
	float4 pos		: POSITION				// W
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);
	Out.ProjPos = Out.Pos;
	Out.EfTexUV = Out.Pos.xy;

	return Out;
}


/*****  sNZVF[_  *****/

// o[g
float4 PSBasic(VS_OUT In) : COLOR0
{
	float2 efTexPos = (float2)0;
	efTexPos.x = In.EfTexUV.x * 0.03125f;			// 0.03125f == 1 / 32.0f
	efTexPos.y = -1 * (In.EfTexUV.y * 0.041666f);	// 0.041666f == 1 / 24.0f
	efTexPos += Offset;
	float4 efColor = (float4)0;
	efColor = tex2D(EfTexSmp, efTexPos);
	efColor.rgb += 0.2f;

	float4 RTColor = (float4)0;
	float2 RTTexUV = In.ProjPos.xy / In.ProjPos.w;
	RTTexUV = max(0, RTTexUV);
	RTTexUV = min(1.0f, RTTexUV);
	RTTexUV.x *= 0.625f;			// 0.625f == 640 / 1024
	RTTexUV.y *= 0.9375f;			// 0.9375f == 480 / 512
	RTColor = tex2D(RTTexSmp, RTTexUV + RTTexel * 0.5);

	float4 retCol = efColor * RTColor;
	retCol.a *= Alpha;

	return retCol;
}

/*****  eNjbN  *****/
technique Normal {

	// Normal
	pass P01
	{
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSBasic();
	}
}