//
// CommunicateEffect.fx
// 
//		


/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;								// [hs
float4x4	mView;								// r[s
float4x4	mProj;								// es
float4		Color;								// J[
float		Alpha = 1.0f;								// At@l

														// Core(cr)
float		crOffset;
float4x4	mCrWrWorld;

// Head(hd)


// Body(bd)


// BodySide(bds)
float		bdsSinPower;
float		bdsAlpha;
float		bdsFrame;

// Arm(am)


// Source(sr)
float		srPower;

// HaveKey(hk)
float4x4	hkWorld;
float		hkAlpha;


/*****  eNX`  *****/
// C
texture Tex;
sampler TexSmp = sampler_state {
	Texture = <Tex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

// Core
texture CoreTex;
sampler CoreTexSmp = sampler_state {
	Texture = <CoreTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

// HaveKey
texture HaveKeyTex;
sampler HaveKeyTexSmp = sampler_state {
	Texture = <HaveKeyTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

texture SideTex;
sampler SideTexSmp = sampler_state {
	Texture = <SideTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = GAUSSIANQUAD;
	AddressU = Wrap;
	AddressV = Clamp;
};

/*****  \  *****/
// _VF[_sNZVF[_ɓn\

// ʏ
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float3 WorldPos	: TEXCOORD1;	// 3DW
	float2 TexUV	: TEXCOORD0;	// eNX`UV
	float4 Col		: COLOR0;		// _J[
	float3 Normal	: TEXCOORD2;	// @
};

/*****  _VF[_  *****/
VS_OUT VSBasic(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,					// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);

	Out.TexUV = texUV;

	Out.Normal = normal.xyz;

	return Out;
}

VS_OUT VSCore(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,					// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mCrWrWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);

	Out.TexUV = texUV;

	Out.Normal = normal.xyz;

	return Out;
}

VS_OUT VSHaveKey(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,					// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, hkWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);

	Out.TexUV = texUV;

	Out.Normal = normal.xyz;

	return Out;
}

/*

*/

/*****  sNZVF[_  *****/
float4 PSBasic(VS_OUT In) : COLOR0
{
	//float4 retCol = Color;
	float4 retCol = tex2D(TexSmp, In.TexUV);
	retCol.a = Alpha;
	return retCol;
	//return float4(1, 0, 0, 1);
}

float4 PSCore(VS_OUT In) : COLOR0
{
	float4 retCol = Color;
	return Color;
}

float4 PSCoreWrap(VS_OUT In) : COLOR0
{
	float2 texUV = In.TexUV;
	texUV.y += crOffset;
	float4 texCol = tex2D(CoreTexSmp, texUV);
	float4 retCol = Color;
	retCol.a = texCol.r;
	return retCol;
}

float4 PSBodySide(VS_OUT In) : COLOR0
{
	float2 texUV = In.TexUV;
	float tmp = In.TexUV.x * 3.14159265 * 8;
	texUV.y *= 1 + sin(tmp) * bdsSinPower;
	texUV.x += bdsFrame;

	float4 texCol = tex2D(SideTexSmp, texUV);
	float4 retCol = float4(0.6,0.6,0.6,1);
	retCol.a = texCol.r;
	return retCol;
}

float4 PSSource(VS_OUT In) : COLOR0
{
	float4 retCol = Color;
	//Color.a = 0.5f;
	return retCol;
}

float4 PSHaveKey(VS_OUT In) : COLOR0
{
	float4 retCol = float4(1.0, 1.0, 0, 1.0f);
	float4 texCol = tex2D(HaveKeyTexSmp, In.TexUV);
	retCol.a = texCol.r;
	retCol.a *= hkAlpha;
	return retCol;
}

/*****  eNjbN  *****/
technique Tech {

	// pass 0
	pass Core
	{
		VertexShader = compile vs_3_0 VSCore();
		PixelShader = compile ps_3_0 PSCore();
	}

	// pass 1
	pass CoreWrap
	{
		VertexShader = compile vs_3_0 VSCore();
		PixelShader = compile ps_3_0 PSCoreWrap();

	}

	// pass 2
	pass Head {
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSBasic();
	}

	// pass 3
	pass Body {
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSBasic();
	}

	// pass 4
	pass BodySide {
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSBodySide();
	}

	// pass 5
	pass Arm {
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSBasic();
	}

	// pass 6
	pass Source {
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSBasic();
	}

	// pass 7
	pass HaveKey {
		VertexShader = compile vs_3_0 VSHaveKey();
		PixelShader = compile ps_3_0 PSHaveKey();
	}
}
