//
// Effect.fx
// Object : Goal
//


/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;								// [hs
float4x4	mView;								// r[s
float4x4	mProj;								// es

float2		NoiseUV;							// mCYUVItZbgl
float		DistVal = -0.03f;						// cݗ
float		DistOffset = 0;						// c݂̃ItZbg

/*****  eNX`  *****/
// C
texture Tex;
sampler TexSmp = sampler_state {
	Texture = <Tex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

// mCY
texture Noise;
sampler NoiseSmp = sampler_state {
	Texture = <Noise>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

// c݃}bv
texture Distortion;
sampler DistortionSmp = sampler_state {
	Texture = <Distortion>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

/*****  \  *****/
// _VF[_sNZVF[_ɓn\

// ʏ
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float2 TexUV	: TEXCOORD0;	// eNX`UV
};


/*****  _VF[_  *****/

VS_OUT VS(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,				// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);

	Out.TexUV = texUV;

	return Out;
}


/*****  sNZVF[_  *****/

float4 PS(VS_OUT In) : COLOR0
{
	float2 distUV = In.TexUV;
	distUV.y += DistOffset;
	float4 distCol = tex2D(DistortionSmp, distUV);

	float2 texUV = In.TexUV;
	texUV.x += DistVal * distCol.w;

	float4 texCol = tex2D(TexSmp, texUV);
	float4 noiseCol = tex2D(NoiseSmp, texUV + NoiseUV);
	float4 retCol = texCol * noiseCol;
	retCol.a = 0.7f;

	return retCol;
}

/*****  eNjbN  *****/
technique Tech {
	pass Main {
		VertexShader = compile vs_3_0 VS();
		PixelShader = compile ps_3_0 PS();
	}
}