//
// Effect.fx
// Object : Goal
//


/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;								// [hs
float4x4	mView;								// r[s
float4x4	mProj;								// es

float		Alpha = 1.0f;						// At@

float2		UVOffset;							// ItZbg

/*****  eNX`  *****/
// C
texture Tex;
sampler TexSmp = sampler_state {
	Texture = <Tex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

// At@}bv
texture AlphaMap;
sampler AlphaMapSmp = sampler_state {
	Texture = <AlphaMap>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Clamp;
	AddressV = Clamp;
};

/*****  \  *****/
// _VF[_sNZVF[_ɓn\

// ʏ
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float2 TexUV	: TEXCOORD0;	// eNX`UV
	float3 Normal	: TEXCOORD1;	// @
};


/*****  _VF[_  *****/

VS_OUT VSBasic(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,				// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);

	Out.TexUV = texUV;

	Out.Normal = normal.xyz;

	return Out;
}

VS_OUT VSEffect01(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,				// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);

	Out.TexUV = texUV;

	return Out;
}


/*****  sNZVF[_  *****/

// o[g
float4 PSBasic(VS_OUT In) : COLOR0
{
	float4 retCol = tex2D(TexSmp, In.TexUV);
	retCol.a *= Alpha;
	return retCol;
}

float4 PSEffect01(VS_OUT In) : COLOR0
{
	float4 alpha = tex2D(AlphaMapSmp, In.TexUV);

	float2 texUV = In.TexUV + UVOffset;
	float4 texCol;
	texCol = tex2D(TexSmp, texUV);

	texCol.a *= alpha.x;
	texCol.a *= Alpha;

	clip(texCol.a - 0.001);
	return texCol;
}


/*****  eNjbN  *****/
technique Tech {
	pass Main {
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSBasic();
	}

	pass Effect01 {
		VertexShader = compile vs_3_0 VSEffect01();
		PixelShader = compile ps_3_0 PSEffect01();
		CullMode = CCW;
	}
}