//
// HDD.fx
// Pass
//		0	:	Body
//		1	:	Side
//		2	:	Connection


/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;								// [hs
float4x4	mView;								// r[s
float4x4	mProj;								// es
float3		LightDir;							// Cg
float3		EyePos;								// _ʒu
float4		Diffuse = 1.0f;						// {F
float		Ambient = 0.0f;						// F
float4		Specular = 1.0f;					// ːF
float		Power = 1.0f;						// ˂̗

float4		Color;
float		OffsetV;

float		DeformV;							// cވʒu
float		DeformRange = 0.5f;				// cޔ͈
float2		ProjTexel;
float2		TexTexel;

/*****  eNX`  *****/
// C
texture Tex;
sampler TexSmp = sampler_state {
	Texture = <Tex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

// eeNX`
texture ProjTex;
sampler ProjTexSmp = sampler_state {
	Texture = <ProjTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

// mCY eNX`
texture NoiseTex;
sampler NoiseTexSmp = sampler_state {
	Texture = <NoiseTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};


/*****  \  *****/
// _VF[_sNZVF[_ɓn\

// ʏ
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float3 WorldPos	: TEXCOORD1;	// 3DW
	float2 TexUV	: TEXCOORD0;	// eNX`UV
	float4 Col		: COLOR0;		// _J[
	float3 Normal	: TEXCOORD2;	// @
};


/*****  _VF[_  *****/

// o[g
VS_OUT VSBasic(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,				// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);

	Out.TexUV = texUV;

	Out.Normal = normalize(mul(normal.xyz, (float3x3)mWorld));

	return Out;
}


/*****  sNZVF[_  *****/

// o[g
float4 PSBasic(VS_OUT In) : COLOR0
{
	float3 L = -LightDir;
	float LPow = max(0, dot(L, In.Normal));

	float3 vCam = normalize(EyePos - In.WorldPos);		// (J)ւ̕
	float3 vRef = LightDir + 2.0f * dot(In.Normal, L) * In.Normal;
	float SpePow = pow(max(0, dot(vCam, vRef)), 2.0f);
	float4 Spe = Specular * SpePow;

	float4 Col = (float4)0;
	Col = Diffuse * tex2D(TexSmp, In.TexUV);
	Col.rgb *= min(1, LPow + Ambient);

	return Col + Spe;
}

float4 PSProj(VS_OUT In) : COLOR0
{
	float2 texUV = In.TexUV + ProjTexel * 0.5;
	float4 defCol = tex2D(TexSmp, In.TexUV + float2(0, DeformV * ProjTexel.y * 2));
	texUV.x += defCol.r * (60.0f * ProjTexel.x);
	float4 texCol = tex2D(ProjTexSmp, texUV);

	float4 noise = tex2D(NoiseTexSmp, texUV + (DeformV * ProjTexel * 120));
	texCol += noise * 0.4f;

	float4 alphaCol = tex2D(TexSmp, In.TexUV + TexTexel * 0.5f);
	texCol.a = alphaCol.g;

	return texCol;
}

/*****  eNjbN  *****/
technique tech {
	pass Body {
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSBasic();
	}

	pass Proj {
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSProj();
	}
}