//
// RadioWaveEffect.fx
// Pass
//		0	:	Normal Effect


/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;								// [hs
float4x4	mView;								// r[s
float4x4	mProj;								// es
float4		LightDir;							// Cg
float4		EyePos;								// _ʒu
float4		Diffuse;							// fBt[Y
float4		ColorRatio;							// F䗦
float4		ProjCenter;							// SW
float2		RTTexel;

/*****  eNX`  *****/
// C
texture Tex;
sampler TexSmp = sampler_state {
	Texture = <Tex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

// _[^[Qbg
texture RTTex;
sampler RTTexSmp = sampler_state {
	Texture = <RTTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Clamp;
	AddressV = Clamp;
};



/*****  \  *****/
// _VF[_sNZVF[_ɓn\

// ʏ
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float3 WorldPos	: TEXCOORD1;	// 3DW
	float2 TexUV	: TEXCOORD0;	// eNX`UV
	float4 EfPos	: TEXCOORD2;	// PSp2DW
};

/*****  ėp֐  *****/
float2 CalcScreenPos(float4 _pos)
{
	float2 Out = _pos.xy / _pos.w;
	Out = Out * 0.5f + 0.5f;
	Out.y = 1 - Out.y;
	Out.x *= 0.625f;		// 0.625f == 640 / 1024
	Out.y *= 0.9375f;		// 0.9375f == 480 / 512
	return Out;
}

/*****  _VF[_  *****/
VS_OUT VSBasic(
	float4 pos		: POSITION,				// W
	float2 texUV	: TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);
	Out.EfPos = Out.Pos;

	Out.TexUV = texUV;

	return Out;
}

/*

*/

/*****  sNZVF[_  *****/
float4 PSBasic(VS_OUT In) : COLOR0
{
	float4 retCol = Diffuse;
	float4 texCol = tex2D(TexSmp, In.TexUV);
	clip(texCol.r - 0.01);
	retCol.a *= texCol.r;
	
	float2 rtuv = In.EfPos.xy / In.EfPos.w;
	rtuv = rtuv * 0.5f + 0.5f;
	rtuv.y = 1 - rtuv.y;

	float2 dir = rtuv - ProjCenter.xy;
	float len = length(dir);
	dir = normalize(dir);
	rtuv += dir * len;

	rtuv = max(RTTexel * 0.5, rtuv);
	rtuv = min(1 - RTTexel * 0.5, rtuv);

	rtuv.x *= 0.625f;		// 0.625f == 640 / 1024
	rtuv.y *= 0.9375f;		// 0.9375f == 480 / 512

	//float2 rtuv = CalcScreenPos(In.EfPos);
	float4 rtCol = tex2D(RTTexSmp, rtuv);
	//retCol.rgb += rtCol.rgb;
	retCol.rgb = retCol.rgb * 0.8 + rtCol.rgb * 0.4;

	return retCol;
	//return rtCol;
}


/*****  eNjbN  *****/
technique Normal {

	// Normal
	pass P01
	{
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PSBasic();
		CullMode = CCW;
		ZEnable = false;
		ZWriteEnable = false;
	}
}