//
// Effect.fx
// Object : Goal
//


/*****  O[oϐ  *****/
// {ϐ
float4x4	mWorld;								// [hs
float4x4	mView;								// r[s
float4x4	mProj;								// es

float		Alpha = 1.0f;						// At@

float2		UVOffset;							// ItZbg
float		Frame = 0;							// t[
float		EfAlpha = 1.0f;

/*****  eNX`  *****/
// CeLXg
texture Tex;
sampler TexSmp = sampler_state {
	Texture = <Tex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

// 
texture NumTex;
sampler NumTexSmp = sampler_state {
	Texture = <NumTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Clamp;
	AddressV = Clamp;
};

// 
texture LineTex;
sampler LineTexSmp = sampler_state {
	Texture = <LineTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Clamp;
	AddressV = Clamp;
};

// GtFNg
texture LineEfTex;
sampler LineEfTexSmp = sampler_state {
	Texture = <LineEfTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Clamp;
	AddressV = Clamp;
};

/*****  \  *****/
// _VF[_sNZVF[_ɓn\

// ʏ
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float2 TexUV	: TEXCOORD0;	// eNX`UV
};


/*****  _VF[_  *****/

VS_OUT VSBasic(
	float4 pos		: POSITION,				// W
	float3 normal : NORMAL,				// @
	float2 texUV : TEXCOORD0				// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);

	Out.TexUV = texUV;

	return Out;
}


/*****  sNZVF[_  *****/

float4 PS01(VS_OUT In) : COLOR0
{
	float4 retCol = tex2D(TexSmp, In.TexUV + UVOffset);
	retCol.a *= Alpha;
	return retCol;
}

float4 PS02(VS_OUT In) : COLOR0
{
	float4 retCol = tex2D(NumTexSmp, In.TexUV + UVOffset);
	retCol.a *= Alpha;
	return retCol;
}

float4 PS03(VS_OUT In) : COLOR0
{
	clip((In.TexUV.x - Frame) * (-1));

	float4 retCol = tex2D(LineTexSmp, In.TexUV);
	retCol.a *= Alpha;
	return retCol;
}

float4 PS04(VS_OUT In) : COLOR0
{
	float4 retCol = tex2D(LineEfTexSmp, In.TexUV);
	retCol.a *= EfAlpha;
	//retCol.a *= Alpha;
	return retCol;
}

/*****  eNjbN  *****/
technique Tech {
	pass P01 {
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PS01();
	}

	pass P02 {
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PS02();
	}

	pass P03 {
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PS03();
	}

	pass P04 {
		VertexShader = compile vs_3_0 VSBasic();
		PixelShader = compile ps_3_0 PS04();
	}
}