// 
// Disc.fx
// ZNg fBXNIuWFNg
//

float4x4	mWorld;						// [hs
float4x4	mView;						// r[s
float4x4	mProj;						// vWFNVs
float3		LightDir;					// Cg
float3		Eye;						// _ʒu
float4		Diffuse;					// fBt[Y
float		Ambient = 1.0f;				// ArGg
float4		Specular;					// XyL͈
float		SpePower = 10.0f;			// XyLx

float		Offset = 0;						// ItZbgl
float		Range = 0.3f;				// ͈

struct VS_OUT
{
	float4 Pos		: POSITION;
	float4 Color	: COLOR0;
	float2 TexUV	: TEXCOORD0;
	float3 Normal	: TEXCOORD1;   //IuWFNg̖@xNg
	float3 WorldPos	: TEXCOORD2;
};



texture Tex;
sampler TexSmp = sampler_state {
	Texture = <Tex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};


/*****  _VF[_  *****/
VS_OUT VS(
	float4 Pos    : POSITION,
	float4 Normal : NORMAL,
	float2 TexUV : TEXCOORD0)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(Pos, mWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);
	Out.TexUV = TexUV;

	Out.Normal = normalize(mul(Normal.xyz, (float3x3)mWorld));

	return Out;
}

/*****  sNZVF[_  *****/
float4 PSPhong(VS_OUT In) : COLOR0
{
	// @𐳋K
	float3 w_normal = normalize(In.Normal);

	//================================================
	// CeBO(o[g)
	//================================================
	float LPow = max(0, dot(-LightDir, w_normal));	// ̋

	//================================================
	// XyL
	//================================================
	float3 vCam = normalize(Eye - In.WorldPos);		// (J)ւ̕
	float3 vRef = LightDir + 2.0f * dot(w_normal, -LightDir) * w_normal;
	float SpePow = pow(max(0,dot(vCam,vRef)), SpePower);
	float4 Spe = Specular * SpePow;

	//================================================
	// fFZo
	//================================================
	// f̐F
	float4 Col = 1.0f;
	// Cg̓̋+
	Col.rgb = min(1, LPow + Ambient);

	//================================================
	// Fo
	//================================================
	//return Col + Spe;
	return float4(0.2, 0.2, 0.2, 1.0);
	//return Spe;
}

float4 PSBlur(VS_OUT In)
{
	float4 texCol = tex2D(TexSmp, In.TexUV);
	texCol *= 0.3f;

	float offset = frac(Offset) * (1.0f + Range * 2.0f) - Range;
	float dif = abs(In.TexUV.y - offset);
	float ratio = 1 - dif / Range;
	if (ratio < 0.0) { return texCol; }
	if (texCol.r > 0.01f) { texCol += 0.6f * ratio; }
	return texCol;
}

float4 PSBack(VS_OUT In) : COLOR0
{
	float4 phongCol = PSPhong(In);
	float4 blurCol = PSBlur(In);

	float4 retCol = phongCol + blurCol;
	return retCol;
	//return phongCol;
}

technique Tech
{
	pass P01
	{
		VertexShader = compile vs_3_0 VS();
		PixelShader = compile ps_3_0 PSBack();
		CullMode = CCW;
	}
}