// 
// Disc.fx
// ZNg fBXNIuWFNg
//

float4x4	mWorld;						// [hs
float4x4	mView;						// r[s
float4x4	mProj;						// vWFNVs
float4		LightDir;					// Cg
float4		Eye;						// _ʒu
float4		Diffuse;					// fBt[Y
float		Ambient = (float)1.0f;		// ArGg
float4		Specular;			// XyL͈
float		SpePower = 10.0f;			// XyLx

float2		DiscTexel;					// fBXN eNZTCY

float2		NameTexel;					// ^O eNZTCY
float		NameYOffset = (float)0;		// ^O YWItZbg
float		NameBlurPos;				// ^O u[Sʒu
float4		NameColor;					// ^OJ[

struct VS_OUT_DISC
{
	float4 Pos		: POSITION;
	float4 Color	: COLOR0;
	float2 TexUV	: TEXCOORD0;
	float3 Normal	: TEXCOORD1;   //IuWFNg̖@xNg
	float3 WorldPos	: TEXCOORD2;
};

struct VS_OUT_NAME
{
	float4 Pos		: POSITION;		// W
	float2 TexUV	: TEXCOORD0;	// UVW
	float3 Normal	: TEXCOORD1;	// @
};


texture DiscTex;
sampler DiscTexSmp = sampler_state {
	Texture = <DiscTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

texture NameTex;
sampler NameTexSmp = sampler_state {
	Texture = <NameTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

/*****  _VF[_  *****/
// fBXN
VS_OUT_DISC VSDisc(
	float4 Pos    : POSITION,
	float4 Normal : NORMAL,
	float2 TexUV : TEXCOORD0)
{
	VS_OUT_DISC Out = (VS_OUT_DISC)0;

	Out.Pos = mul(Pos, mWorld);
	Out.WorldPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);
	Out.TexUV = TexUV;

	Out.Normal = normalize(mul(Normal.xyz, (float3x3)mWorld));

	return Out;
}

// ^O
VS_OUT_NAME VSName(
	float4 Pos    : POSITION,
	float4 Normal : NORMAL,
	float2 TexUV : TEXCOORD0
	)
{
	VS_OUT_NAME Out = (VS_OUT_NAME)0;

	Out.Pos = mul(Pos, mWorld);
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);
	Out.TexUV = TexUV;
	Out.Normal = normalize(Normal.xyz);

	return Out;
}


/*****  sNZVF[_  *****/

// fBXN
float4 PSDisc(VS_OUT_DISC In) : COLOR0
{
	// @𐳋K
	float3 w_normal = normalize(In.Normal);

	//================================================
	// CeBO(o[g)
	//================================================
	float LPow = max(0, dot(-LightDir.xyz, w_normal));	// ̋

	//================================================
	// XyL
	//================================================
	float3 vCam = normalize(Eye.xyz - In.WorldPos);		// (J)ւ̕
	float3 vRef = LightDir.xyz + 2.0f * dot(w_normal, -LightDir.xyz) * w_normal;
	float SpePow = pow(max(0,dot(vCam,vRef)), SpePower);
	float4 Spe = Specular * SpePow;

	//================================================
	// fFZo
	//================================================
	// f̐F
	float4 Col = Diffuse * tex2D(DiscTexSmp, In.TexUV);
	// Cg̓̋+
	Col.rgb *= min(1, LPow + Ambient);

	//================================================
	// Fo
	//================================================
	return Col + Spe;
	//return Spe;
}

// x
float4 PSLabel(VS_OUT_NAME In) : COLOR0
{
	float4 retCol = tex2D(NameTexSmp, In.TexUV) * NameColor;
	return retCol;
}

float4 PSName(VS_OUT_NAME In) : COLOR0
{
	float2 texUV = In.TexUV + float2(0, NameYOffset);
	float4 texCol = tex2D(NameTexSmp, texUV);
	
	float4 blur = (float4)0;
	for (int i = 0; i < 4; i++) {
		blur += tex2D(NameTexSmp, texUV + float2(NameTexel.x * i * 0.5, 0));
		blur += tex2D(NameTexSmp, texUV - float2(NameTexel.x * i * 0.5, 0));
		blur += tex2D(NameTexSmp, texUV + float2(0, NameTexel.y * i * 0.5));
		blur += tex2D(NameTexSmp, texUV - float2(0, NameTexel.y * i * 0.5));
	}
	// 0.083333 = 1.0 / 12.0f;
	blur *= 0.083333;

	float4 retCol;
	retCol = texCol;
	//retCol = texCol * NameColor;
	//retCol.rgb += blur.rgb;

	return retCol;
}

technique Tech
{
	pass Disc
	{
		VertexShader = compile vs_3_0 VSDisc();
		PixelShader = compile ps_3_0 PSDisc();
		CullMode = CCW;
	}

	pass Label {
		VertexShader = compile vs_3_0 VSName();
		PixelShader = compile ps_3_0 PSLabel();
	}

	pass Name
	{
		VertexShader = compile vs_3_0 VSName();
		PixelShader = compile ps_3_0 PSName();
	}
}