// 
// Disc.fx
// ZNg fBXNIuWFNg
//

float4x4	mWorld;						// [hs
float4x4	mView;						// r[s
float4x4	mProj;						// vWFNVs
float4		Color;

struct VS_OUT {
	float4 Pos	:	POSITION;
	float2 TexUV:	TEXCOORD0;
};

texture Tex;
sampler TexSmp = sampler_state {
	Texture = <Tex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Clamp;
	AddressV = Clamp;
};

/*****  _VF[_  *****/
VS_OUT VS(
	float4 Pos		: POSITION,
	float2 TexUV	: TEXCOORD0
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(Pos, mWorld);
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);
	Out.TexUV = TexUV;

	return Out;
}


/*****  sNZVF[_  *****/
float4 PS(VS_OUT In)	:	COLOR0
{
	float4 retCol = tex2D(TexSmp, In.TexUV) * Color;
	return retCol;
}

technique Tech
{
	pass Pass0
	{
		VertexShader = compile vs_3_0 VS();
		PixelShader = compile ps_3_0 PS();
		CullMode = CCW;
	}
}