//
// Basic.fx
// WIȎVF[_񋟂
//
// Pass
//		0	:	o[gVF[fBO
//		1	:	o[gVF[fBO(+Fݒ)
//		2	:	n[to[gVF[fBO
//		3	:	n[to[gVF[fBO(+Fݒ)
//		4	:	tHVF[fBO
//		5	:	tHVF[fBO(+Fݒ)
//
// Pass 0,1		o[gVF[fBO
//		mWVP			:	[hEr[ˉeWϊs	
//		LightDir		:	Cg
//		Ambient			:	ArGg()
//
// Pass 2,3		n[to[gVF[fBO
//		mWVP			:	[hEr[ˉeWϊs	
//		LightDir		:	Cg
//		Ambient			:	ArGg()
//
// Pass 4,5		tHVF[fBO
//		mWVP			:	[hEr[ˉeWϊs	
//		LightDir		:	Cg
//		EyePos			:	_ʒu
//		Ambient			:	ArGg()
//		Specular		:	XyL͈
//		SpecularPower	:	XyLx
//
// Pass 6,7		AeVF[fBO
//		mWVP			:	[hEr[ˉeWϊs	
//		LightDir		:	Cg
//		Ambient			:	ArGg()




/*****  O[oϐ  *****/
float4x4	mWorld;
float4x4	mView;
float4x4	mProj;
float4		LightDir;						// Cg
float4		EyePos;							// _ʒu
float		Ambient = 0.0f;					// 
float4		Diffuse;						// fBt[Y
float4		Specular;						// XyLF
float		Power = 0.0f;					// XyLx
float4		ColorRatio = float4(1,1,1,1);	// F̔


/*****  Tv  *****/
texture MeshTex;
sampler MeshSmp = sampler_state {
	Texture = <MeshTex>;
	MipFilter = LINEAR;	
	MinFilter = LINEAR; 
	MagFilter = LINEAR; 
	AddressU = Wrap;
	AddressV = Wrap;
};



/*****  \  *****/
// _VF[_sNZVF[_ɓn\
struct VS_OUT_Lambert
{
	float4 Pos		: POSITION;		// 2DW
	float2 MeshUV	: TEXCOORD0;	// eNX`UV
	float4 Col		: COLOR0;		// _J[
};

struct VS_OUT_HalfLambert
{
	float4 Pos		: POSITION;		// 2DW
	float2 MeshUV	: TEXCOORD0;	// eNX`UV
	float3 Normal	: TEXCOORD1;	// _J[
};

struct VS_OUT_Phong
{
	float4	Pos		: POSITION;
	float4	Col		: COLOR0;
	float2	MeshUV	: TEXCOORD0;
	float3	wPos	: TEXCOORD1;
	float3	Normal	: TEXCOORD2;
};


/*****  ֐  *****/

/*****  _VF[_  *****/

// o[ggUƖ
VS_OUT_Lambert VSLambert(
	float4 pos		: POSITION,				// W
	float3 normal	: NORMAL,				// @
	float2 texUV	: TEXCOORD0			// eNX`UV
	)
{
	VS_OUT_Lambert Out = (VS_OUT_Lambert)0;

	// _̍Wsϊ
	Out.Pos = mul(pos, mWorld);
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);

	// eNX`W
	Out.MeshUV = texUV;

	// Cgtɂ
	float3 L = -LightDir.xyz;

	// @xNg
	float3 N = normal.xyz;

	// ƖƖ@̓ςƊmaxl
	Out.Col = max(Ambient, dot(N, L));

	return Out;
}

// n[to[g
VS_OUT_HalfLambert VSHalfLambert(
	float4 pos		: POSITION,				// W
	float3 normal	: NORMAL,				// @
	float2 texUV	: TEXCOORD0			// eNX`UV
	)
{
	VS_OUT_HalfLambert Out = (VS_OUT_HalfLambert)0;

	// _̍Wsϊ
	Out.Pos = mul(pos, mWorld);
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);

	// eNX`W
	Out.MeshUV = texUV;

	// @xNg
	Out.Normal = normal.xyz;

	return Out;
}

// tHVF[fBO
VS_OUT_Phong VSPhong(
	float4 pos		: POSITION,
	float3 normal	: NORMAL,
	float2 texUV	: TEXCOORD0
	)
{
	VS_OUT_Phong Out = (VS_OUT_Phong)0;

	Out.Pos = mul(pos, mWorld);
	Out.wPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);
	Out.MeshUV = texUV;

	float3 w_normal = normalize(mul(normal, (float3x3)mWorld));
	Out.Normal = w_normal;

	return Out;
}

// AeȂ
VS_OUT_Lambert VSOrigin(
	float4 pos		: POSITION,
	float2 texUV	: TEXCOORD0
	)
{
	VS_OUT_Lambert Out = (VS_OUT_Lambert)0;
	Out.Pos = mul(pos, mWorld);
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);
	Out.MeshUV = texUV;
	return Out;
}



/*****  sNZVF[_  *****/

// o[ggUƖ
float4 PSLambert(VS_OUT_Lambert In) : COLOR0
{
	float4 Out = (float4)0;
	Out = In.Col * tex2D(MeshSmp, In.MeshUV);
	return Out;
}

float4 PSLambertColor(VS_OUT_Lambert In) : COLOR0
{
	float4 color;
	color = PSLambert(In);
	return color * ColorRatio;
}

// n[to[g
float4 PSHalfLambert(VS_OUT_HalfLambert In) : COLOR0
{
	float4 Out;
	float p = dot(In.Normal, -LightDir.xyz);
	p = p * 0.5f + 0.5;
	p = p * p;

	Out = p * tex2D(MeshSmp, In.MeshUV);

	return Out;
}

float4 PSHalfLambertColor(VS_OUT_HalfLambert In) : COLOR0
{
	float4 color;
	color = PSHalfLambert(In);
	return color * ColorRatio;
}

// tHVF[fBO
float4 PSPhong(VS_OUT_Phong In) : COLOR0
{
	// @𐳋K
	float3 w_normal = normalize(In.Normal);

	float LPow = max(0, dot(-LightDir.xyz, w_normal));

	float3 vCam = normalize(EyePos.xyz - In.wPos);
	float3 vRef = LightDir.xyz + 2.0f * dot(w_normal, -LightDir.xyz) * w_normal;
	float SpePow = pow(max(0,dot(vCam,vRef)), Power);
	float4 Spe = Specular * SpePow;

	float4 Col = Diffuse * tex2D(MeshSmp, In.MeshUV);
	Col.rgb *= min(1, LPow + Ambient);

	return Col + Spe;
}


float4 PSPhongColor(VS_OUT_Phong In) : COLOR0
{
	float4 color;
	color = PSPhong(In);
	return color * ColorRatio;
}

// AeȂ
float4 PSOrigin(VS_OUT_Lambert In) : COLOR0
{
	float4 Out = (float4)0;
	Out = tex2D(MeshSmp, In.MeshUV);
	return Out;
}

float4 PSOriginColor(VS_OUT_Lambert In) : COLOR0
{
	float4 color;
	color = PSOrigin(In);
	return color * ColorRatio;
}



/*****  eNjbN  *****/
technique Basic
{
	pass P0
	{
		VertexShader = compile vs_3_0 VSLambert();
		PixelShader = compile ps_3_0 PSLambert();
	}

	pass P1
	{
		VertexShader = compile vs_3_0 VSLambert();
		PixelShader = compile ps_3_0 PSLambertColor();
	}

	pass P2
	{
		VertexShader = compile vs_3_0 VSHalfLambert();
		PixelShader = compile ps_3_0 PSHalfLambert();
	}

	pass P3
	{
		VertexShader = compile vs_3_0 VSHalfLambert();
		PixelShader = compile ps_3_0 PSHalfLambertColor();
	}

	pass P4
	{
		VertexShader = compile vs_3_0 VSPhong();
		PixelShader = compile ps_3_0 PSPhong();
	}

	pass P5
	{
		VertexShader = compile vs_3_0 VSPhong();
		PixelShader = compile ps_3_0 PSPhongColor();
	}

	pass P6
	{
		VertexShader = compile vs_3_0 VSOrigin();
		PixelShader = compile ps_3_0 PSOrigin();
	}

	pass P7
	{
		VertexShader = compile vs_3_0 VSOrigin();
		PixelShader = compile ps_3_0 PSOriginColor();
	}
}
