//
// Blur.fx
// u[VF[_񋟂
//
//
//
//

float2	Texel;		// eNZTCY
int		Range = 5;	// ͈
float	InvDiv = 1.0f / ((5 * 2.0f) + 2.0f);		// 1 / Z

texture	InputTex;
sampler InputSmp = sampler_state {
	Texture = <InputTex>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = Clamp;
	AddressV = Clamp;
};

float4 PSNormal(float2 uv : TEXCOORD0) : COLOR0
{
	uv += Texel * 0.5f;
	float4 color = tex2D(InputSmp, uv);
	clip((color.r + color.g + color.b) - 0.000001);
	return color;
}

float4 PSBlurX(float2 uv : TEXCOORD0)	:	COLOR0
{
	float4 color = (float4)0;

	int loop = Range;
	for (int i = 0; i <= 5; i++) {
		if (i > Range) { break; }
		color += tex2D(InputSmp, uv + float2(Texel.x * i, 0));
		color += tex2D(InputSmp, uv + float2(-Texel.x * i, 0));
	}

	// Zl̓AvP[VŌvZ邱
	//color *= InvDiv;
	color *= 1.0f / 10.0f ;

	return color;
}

float4 PSBlurY(float2 uv : TEXCOORD0) : COLOR0
{
	float4 color = (float4)0;
	
	int loop = Range;
	for (int i = 0; i <= 5; i++) {
		color += tex2D(InputSmp, uv + float2(0, Texel.y * i));
		color += tex2D(InputSmp, uv + float2(0, -Texel.y * i));
	}

	// Zl̓AvP[VŌvZ邱
	//color *= InvDiv;
	color *= 1.0f / 10.0f;

	return color;
}


technique Normal {
	pass Normal {
		PixelShader = compile ps_3_0 PSNormal();
		ZWriteEnable = false;	// ZOFF
		ZEnable = false;		// ZOFF
	}
};

technique Blur {
	pass XBlur {
		PixelShader = compile ps_3_0 PSBlurX();
		ZWriteEnable = false;	// ZOFF
		ZEnable = false;		// ZOFF
	}

	pass YBlur {
		PixelShader = compile ps_3_0 PSBlurY();
		ZWriteEnable = false;	// ZOFF
		ZEnable = false;		// ZOFF
	}
}