//
// PostEffect.fx
// {Iȃ|XgGtFNgnVF[_񋟂B
// CeBO̓o[gōs
//
// Pass
//		0	:	lK|W]
//		1	:	lK|W](+At@l)
//		2	:	mN
//		3	:	mN(+At@l)
//		4	:	ZsA
//		5	:	ZsA(+At@l)



/*****  O[oϐ  *****/
float4x4	mWorld;
float4x4	mView;
float4x4	mProj;
float4		LightDir;							// Cg
float4		Ambient = 0.0f;						// 
float		Alpha = 1.0f;						// At@l
float4		SepiaColor = float4(1.0f, 0.8f, 0.0f, 1.0f);	// ZsÃJ[


/*****  Tv  *****/
texture MeshTex;
sampler MeshSmp = sampler_state {
	Texture = <MeshTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};


/*****  \  *****/
// _VF[_sNZVF[_ɓn\
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float2 MeshUV	: TEXCOORD0;	// eNX`UV
	float4 Col		: COLOR0;		// _J[
};


/*****  ֐  *****/

/*****  _VF[_  *****/

// o[g
VS_OUT VSLambert(
	float4 pos		: POSITION,				// W
	float3 normal	: NORMAL,				// @
	float2 texUV	: TEXCOORD0			// eNX`UV
	)
{
	VS_OUT Out = (VS_OUT)0;

	Out.Pos = mul(pos, mWorld);
	Out.Pos = mul(Out.Pos, mView);
	Out.Pos = mul(Out.Pos, mProj);

	Out.MeshUV = texUV;

	float3 L = -LightDir.xyz;
	float3 N = normal.xyz;
	Out.Col = max(Ambient, dot(N, L));

	return Out;
}


/*****  sNZVF[_  *****/

// o[ggUƖ
float4 PSLambert(VS_OUT In) : COLOR0
{
	float4 Out = (float4)0;
	Out = In.Col * tex2D(MeshSmp, In.MeshUV);
	return Out;
}

float4 PSNega(VS_OUT In) : COLOR0
{
	float4 color;
	color = PSLambert(In);
	color.rgb = 1 - color.rgb;
	return color;
}

float4 PSNegaAlpha(VS_OUT In) : COLOR0
{
	float4 color;
	color = PSLambert(In);
	color.rgb = 1 - color.rgb;
	color.a = color.a * Alpha;
	return color;
}

float4 PSMono(VS_OUT In) : COLOR0
{
	float4 color;
	color = PSLambert(In);
	color.rgb = (color.r + color.g + color.b) * 0.333333f;
	return color;
}

float4 PSMonoAlpha(VS_OUT In) : COLOR0
{
	float4 color;
	color = PSLambert(In);
	color.rgb = (color.r + color.g + color.b) * 0.333333f;
	color.a = color.a * Alpha;
	return color;
}

float4 PSSepia(VS_OUT In) : COLOR0
{
	float4 color;
	color = PSLambert(In);
	color.rgb = (color.r + color.g + color.b) * 0.333333f;
	color = color * SepiaColor;
	return color;
}

float4 PSSepiaAplha(VS_OUT In) : COLOR0
{
	float4 color;
	color = PSLambert(In);
	color.rgb = (color.r + color.g + color.b) * 0.333333f;
	color = color * SepiaColor;
	color.a = color.a * Alpha;
	return color;
}



/*****  eNjbN  *****/
technique PostEffect
{
	pass P0
	{
		VertexShader = compile vs_3_0 VSLambert();
		PixelShader = compile ps_3_0 PSNega();
	}

	pass P1
	{
		VertexShader = compile vs_3_0 VSLambert();
		PixelShader = compile ps_3_0 PSNegaAlpha();
	}

	pass P2
	{
		VertexShader = compile vs_3_0 VSLambert();
		PixelShader = compile ps_3_0 PSMono();
	}

	pass P3
	{
		VertexShader = compile vs_3_0 VSLambert();
		PixelShader = compile ps_3_0 PSMonoAlpha();
	}

	pass P4
	{
		VertexShader = compile vs_3_0 VSLambert();
		PixelShader = compile ps_3_0 PSSepia();
	}

	pass P5
	{
		VertexShader = compile vs_3_0 VSLambert();
		PixelShader = compile ps_3_0 PSSepiaAplha();
	}
}